#include <fxlib.h>
#include "simpleLib.h"

#ifdef SL_RAND
__asm__(
".global _GetTicks\n"
"_GetTicks:\n"
"mov.l syscall_table, r2\n"
"mov.l 1f, r0\n"
"jmp @r2\n"
"nop\n"
"1:\n"
".long 0x03B\n"
"syscall_table:\n"
".long 0x80010070\n"
);

static unsigned int lastrandom=0x12345678;

unsigned int rand() {
	lastrandom = ( 0x41C64E6D * lastrandom ) + 0x3039;
	return (lastrandom >> 16);
}

void srand(int s) {
	lastrandom+=s;
}
#endif

#ifdef SL_INTTOSTRING
void intToString(int n, char **s) {
	if(n < 0) n*=-1;
	int i = 1, m = n;
	while(m/=10) ++i;
	*s = (char *)realloc(*s, sizeof(char)*(i+1));
	(*s)[i] = 0;
	do
		(*s)[--i] = '0' + n%10;
	while(n/=10);
}
#endif

#ifdef SL_PRINTFORMA
void printForma(int x, int y, char *s) {
	int i = 0;
	while(s[i] != '\n' && s[i]) ++i;
	if(s[i]) {
		s[i] = 0;
		PrintMini(x, y, s, 0);
		printForma(x, y+7, s+i+1);
	} else PrintMini(x, y, s, 0);
}
#endif

#ifdef SL_RECT
void rect(int x1, int y1, int x2, int y2) {
	line(x1, y1, x2, y1);
	line(x1, y1, x1, y2);
	line(x2, y2, x2, y1);
	line(x2, y2, x1, y2);
}
#endif
